## shoop 0.1

=== Makefile ===
#!/usr/bin/make -f
#
# This makefile needs GNU make.
#
TOPDIR=$(CURDIR)
prefix=$(CURDIR)/debian/shoop

moddir=/usr/share/shoop/modules
bindir=/usr/share/shoop
docdir=/usr/share/doc/shoop
mandir=/usr/share/man
empdir=$(docdir)/examples

MODULES_MSG=modules
BINS_MSG=binary
DOCS_MSG=documents
EXAMPLES_MSG=examples
MAN_MSG=man pages

DIRS=$(bindir) $(moddir) $(docdir) $(docdir)/examples

SUBDIRS=modules docs

BINS=\
	shoop.sh\

DOCS=\
	COPYING\
	TODO\
	
EXAMPLES=\
	example.sh\

PKG=shoop
PKG_VER=0.1
TOPDIR=.

tinstall = $(CURDIR)/tmp-install

all:
	echo This makefile is only here to run benchmarks or examples,
	echo or install shoop, or do regression tests.
	echo \	make benchmark
	echo \	make example
	echo \	make install
	echo \	make test

test:
	$(MAKE) installmodules installbins prefix=$(tinstall)
	cd $(tinstall); SHOOPPATH=$(tinstall)$(moddir)\
			SHOOPMOD=$(tinstall)$(moddir)\
			SHOOPSH=$(tinstall)$(bindir)/shoop.sh\
			CURDIR=$(CURDIR)\
			$(SHELL) $(CURDIR)/t/regress\
			$(CURDIR)/t/inheritance.sh\

www-test1:
	$(MAKE) installbins installmodules prefix=$(tinstall)
	cd $(tinstall); SHOOPPATH=$(tinstall)$(moddir)\
			SHOOPMOD=$(tinstall)$(moddir)\
			SHOOPSH=$(tinstall)$(bindir)/shoop.sh\
			CURDIR=$(CURDIR)\
			$(CURDIR)/t/benchmark\
			$(CURDIR)/t/kbu.bm\
			""

www-test2:
	$(MAKE) installbins installmodules prefix=$(tinstall)
	cd $(tinstall); SHOOPPATH=$(tinstall)$(moddir)\
			SHOOPMOD=$(tinstall)$(moddir)\
			SHOOPSH=$(tinstall)$(bindir)/shoop.sh\
			CURDIR=$(CURDIR)\
			$(CURDIR)/t/benchmark\
			$(CURDIR)/t/kbhomes.bm\
			""

example:
	sh ./example.sh

benchmark:
	$(MAKE) installbins installmodules prefix=$(tinstall)
	cd $(tinstall); SHOOPPATH=$(tinstall)$(moddir)\
			SHOOPMOD=$(tinstall)$(moddir)\
			SHOOPSH=$(tinstall)$(bindir)/shoop.sh\
			CURDIR=$(CURDIR)\
			$(CURDIR)/t/benchmark\
			$(CURDIR)/t/benchmark.bm\
			"$(bscr)"

clean_dirs=$(tinstall)
clean_files=*~ .\#* ChangeLog docs/modules.pod

#
# Author only targets are below
#

cvs-build:
	rm -rf cvs-build
	$(MAKE) ChangeLog
	tar c --exclude CVS --exclude cvs-build . |\
		(mkdir -p cvs-build/$(PKG)-$(PKG_VER);cd cvs-build/$(PKG)-$(PKG_VER);tar x)

docs/modules.pod: utils/shelldoc $(MODULES)
	rm -f modules_tmp
	$(MAKE) modules_tmp
	utils/shelldoc "SHOOP Modules" $$(cat modules_tmp) > $@
	rm -f modules_tmp

docs/modules.txt: docs/modules.pod

dyndocs: www/modules.html docs/modules.txt
modules_title=SHOOP Modules

%.txt: %.pod
	pod2text < $< > $@
%.html: %.pod
	pod2html --title "$($(*F)_title)"< $< > $@

www/modules.html: docs/modules.html
	cp -a $< $@

clean_files+=www/modules.html docs/modules.txt docs/modules.html docs/modules.pod 
clean_files+=pod2html-dircache pod2html-itemcache

ChangeLog:
	utils/mkChangeLog $@

include $(TOPDIR)/Makefile.rules

.PHONY: docs/modules.pod

=== docs/Makefile ===
#!/usr/bin/make -f
#
# This makefile needs GNU make.
#
TOPDIR=..

DOCS=\
	CONTRIBUTING\
	MODULES\
	README\
	modules.txt\

include $(TOPDIR)/Makefile.rules

=== modules/Makefile ===
#!/usr/bin/make -f
#
# This makefile needs GNU make.
#
TOPDIR=..

MODULES=\
	destroy.sh\
	final.sh\
	introspect.sh\
	prettyprint.sh\
	serialize.sh\
	thread.sh\
	use.sh\
	also_inherit.sh\
	www.sh\
	dns.sh\

include $(TOPDIR)/Makefile.rules

=== debian/changelog ===
shoop (0.1) unstable; urgency=low

  * Initial release (closes: Bug#84406).

 -- Gergely Nagy <8@free.bsd.hu>  Wed, 31 Jan 2001 10:21:08 +0100

Local variables:
mode: debian-changelog
add-log-mailing-address "8@free.bsd.hu"
End:

=== debian/control ===
Source: shoop
Section: devel
Priority: extra
Maintainer: Gergely Nagy <shoop-devel@lists.sourceforge.net>
Build-Depends: debhelper (>= 2.0.40), perl
Standards-Version: 3.5.0

Package: shoop
Architecture: all
Recommends: shoop-modules (>= ${Source-Version})
Description: The SHell Object Oriented Programming library
 Every language under the sun these days is Object Oriented.
 In an effort to make POSIX shell more buzzword compliant, and
 to show that it's really not a big deal for a language to lack
 built-in OO support, we have added object orientation to plain
 old shell script. Specifically, we have implemented classless
 OO with introspection, finalization, serialization, and multiple
 inheritance.

Package: shoop-modules
Architecture: all
Depends: shoop (>= ${Source-Version})
Description: A collection of shoop modules
 This package includes various modules for shoop, such as
 introspect, prettyprint, serialize, and some others.
 .
 It is a good idea to have these at hand!

Package: shoop-dev
Architecture: all
Depends: shoop (>= ${Source-Version})
Description: Development files and documention for shoop
 Herein lies example code, utility programs, and documentation
 for shoop, the SHell Object Oriented Programming library.

=== debian/rules ===
#! /bin/sh
## debian/rules for SHOOP
## by Gergely Nagy <algernon@debian.org>
##
## Trapped in time
## A miracle of hope and change
## A swirling mass, no mercy now
## If the truth hurts prepare for pain
## ...Do you think we're forever ?
##
##	- Anathema: Eternity Part I

# exports
export SHOOPPATH=${PWD}:${PWD}/modules
export SHOOPMOD=${PWD}/modules
export DH_COMPAT=2

# #include <shoop>
. ${PWD}/shoop.sh

# basic setup
OBJECT . new DEBIAN

DEBIAN . MAKE_LEVEL =q 0
DEBIAN . dry_run =q no
DEBIAN . verbose =q yes
DEBIAN . keep_going =q no
DEBIAN . DPKG_BUILDPACKAGE =q ${DPKG_BUILDPACKAGE:-dpkg-buildpackage}
DEBIAN . INSTALL_OPTIONS =q ""

# core methods
DEBIAN . do_header : 'echo "==> [$($THIS . MAKE_LEVEL)] Making $@" 1>&2
	$THIS . MAKE_LEVEL =q $(expr $($THIS . MAKE_LEVEL) + 1)'
DEBIAN . do_done : '$THIS . MAKE_LEVEL =q $(expr $($THIS . MAKE_LEVEL) - 1)
	echo "<== [$($THIS . MAKE_LEVEL)] Finished $@" 1>&2'
DEBIAN . do : 'if test "x$($THIS . verbose)" != "xno"; then echo $@; fi
	if test "x$($THIS . dry_run)" = "xno"; then eval $@; fi'
DEBIAN . header : 'if test "x$($THIS . verbose)" != "xno"; then
		$THIS . do_header $@
	fi'
DEBIAN . done : 'if test "x$($THIS . verbose)" != "xno"; then
		$THIS . do_done $@
	fi'

# These do the Real Job
DEBIAN . do_build : 'test -f build-stamp || $THIS . build_stamp'
DEBIAN . do_build_stamp : '$THIS . do dh_testdir
	$THIS . do "make docs/modules.txt 2>/dev/null"
	$THIS . do touch build-stamp'
DEBIAN . do_clean : '$THIS . do dh_testdir
	$THIS . do dh_testroot
	$THIS . do rm -f build-stamp docs/modules.txt docs/modules.pod
# Back up the ChangeLog
	mv ChangeLog ChangeLog.backup
# Clean up!
	$THIS . do "make clean || true"
# Copy the ChangeLog back
	mv ChangeLog.backup ChangeLog
	$THIS . do dh_clean'
DEBIAN . do_install : '$THIS . build
	$THIS . do dh_testdir
	$THIS . do dh_testroot
	$THIS . do dh_clean -k
	$THIS . do dh_installdirs
	$THIS . do make install $($THIS . INSTALL_OPTIONS)
	$THIS . do rm -f debian/shoop/usr/share/doc/shoop/COPYING \
			 debian/shoop/usr/share/doc/shoop/COPYING.gz
	$THIS . do mv debian/shoop/usr/share/shoop/modules \
		      debian/shoop-modules/usr/share/shoop/modules
	$THIS . do mv debian/shoop/usr/share/doc/shoop/modules.txt \
		      debian/shoop-dev/usr/share/doc/shoop/
	$THIS . do mv debian/shoop/usr/share/doc/shoop/MODULES \
		      debian/shoop-dev/usr/share/doc/shoop/
	$THIS . do rm -rf debian/shoop/usr/share/doc/shoop/examples
	$THIS . do ln -sf shoop debian/shoop-dev/usr/share/doc/shoop-dev
	$THIS . do ln -sf shoop debian/shoop-modules/usr/share/doc/shoop-modules
# I have to use ugly IFS magic here, otherwise things would fail miserably
	SAVE_IFS="$IFS"
	GOOD_IFS=" 	
"
	IFS="$GOOD_IFS"
	for f in $(cat debian/shoop-dev.examples); do
		IFS="$SAVE_IFS"
		$THIS . do cp $f debian/shoop-dev/usr/share/doc/shoop/examples/$f
		IFS="$GOOD_IFS"
	done
	IFS="$SAVE_IFS"'
DEBIAN . do_packages : '$THIS . build
	$THIS . install
	$THIS . do dh_testdir
	$THIS . do dh_testroot
#	$THIS . do dh_installdebconf
	$THIS . do dh_installdocs
#	$THIS . do dh_installmenu
#	$THIS . do dh_installinfo
	$THIS . do dh_installchangelogs
# This is Evil.
	$THIS . do rm -f debian/shoop-dev/usr/share/doc/shoop/copyright
	$THIS . do rm -f debian/shoop-dev/usr/share/doc/shoop/changelog{,.gz}
	$THIS . do rm -f debian/shoop-modules/usr/share/doc/shoop/copyright
	$THIS . do rm -f debian/shoop-modules/usr/share/doc/shoop/changelog{,.gz}
# Evil ends here.
	$THIS . do dh_link
	$THIS . do dh_strip
	$THIS . do dh_compress
	$THIS . do dh_fixperms
	$THIS . do dh_installdeb
	$THIS . do dh_gencontrol
	$THIS . do dh_md5sums
	$THIS . do dh_builddeb'
DEBIAN . do_binary_arch : ''
DEBIAN . do_binary_indep : '$THIS . packages'
DEBIAN . do_binary : '$THIS . binary_arch
	$THIS . binary_indep'
DEBIAN . do_cvs_build : '# Oh boy, oh boy!
	$THIS . do make ChangeLog
	$THIS . do $($THIS . DPKG_BUILDPACKAGE)'

# Wrapper function that calls header & done too
DEBIAN . do_func : '$THIS . header $LASTMETH
	$THIS . do_$LASTMETH
	$THIS . done $LASTMETH'
# Use the wrapper for all targets
DEBIAN . build : DEBIAN . do_func
DEBIAN . build_stamp : DEBIAN . do_func
DEBIAN . clean : DEBIAN . do_func
DEBIAN . install : DEBIAN . do_func
DEBIAN . packages : DEBIAN . do_func
DEBIAN . binary_arch : DEBIAN . do_func
DEBIAN . binary_indep : DEBIAN . do_func
DEBIAN . binary : DEBIAN . do_func
DEBIAN . cvs_build : DEBIAN . do_func

# void main ( whatever )
DEBIAN . debian : '# Go Johny, go! Go Johny, go go go!
	while test $# -gt 0
	do
		opt=$1
		shift

		case $opt in
			build|build-stamp|clean|install|packages|binary-arch|binary-indep|binary|cvs-build)
				method=$(echo $opt | sed -e "s,\-,_,g")
				$THIS . TODO .=q $method
				;;
			DEB_BUILD_OPTIONS=*nostrip*)
				$THIS . INSTALL_OPTIONS .=q "strip_comment_space=/bin/cat"
				;;
			DEB_*=*)
				# These are useless for us
				;;
			-*b*|-*m*|-*d*|-*e*|-*i*|-*p*|-*q*|-*r*|-*t*|-*w*|-*C|-*f|-*I|-*o|-*W|-*j*|-*k*|-*s*|-*S-|-*n*|-*l*)
				# Ignored, handled later
				;;
			-*)
				echo "*** Unsupported option: $opt"
				exit 1
				;;
			*)
				echo "*** Unsupported target: $opt"
				exit 1
				;;
		esac
		case $opt in
			-*b*|-*m*|-*d*|-*e*|-*i*|-*p*|-*q*|-*r*|-*t*|-*w*)
				# Ignored for GNU Make compatibility
				;;
		esac
		case $opt in
			-*C|-*f|-*I|-*o|-*W|-*l)
				# Ignored (with arguments) for GNU Make compatibility
				shift
				;;
		esac
		case $opt in
			-*j*)
				# This is not implemented yet
				;;
		esac
		case $opt in
			-*k*)
				$THIS . keep_going =q yes
				;;
		esac
		case $opt in
			-*S*)
				$THIS . keep_going =q no
				;;
		esac
		case $opt in
			-*n*)
				$THIS . dry_run =q yes
				;;
		esac
		case $opt in
			-*s*)
				$THIS . verbose =q no
				;;
		esac
		case $opt in
			-*v*)
				$ THIS . version
				exit 0
				;;
		esac
	done
	$THIS . header debian
	if test "x$($THIS . keep_going)" = "xno"; then
		set -e
	fi
	# FIXME : $THIS . TODO empty => print warning
	for rule in $($THIS . TODO); do
		$THIS . $rule
	done
	$THIS . done debian'

# Run forest, run !
DEBIAN . debian ${@:-build}

exit 0
